package egs.wolves;

import abp.*;

import java.io.File;
import java.io.IOException;

public class Hunt {
  public static void main(String[] args) throws IOException{
    AdaptiveProcess hunt = AdaptiveProcess.init(new File("table"));

    Adaptive<Grid,Move>
      w1 = hunt.initAdaptive(Grid.class,Move.class),
      w2 = hunt.initAdaptive(Grid.class,Move.class);

    Rabbit rabbit = Rabbit.random();
    Grid g0 = Grid.INITIAL;
    while (true) {
      System.out.println(g0);

      Move rabbitMove = rabbit.pickMove(g0);
      Grid g1 = g0.moveRabbit(rabbitMove);

      // ... pick move for wolf 1
      Move wolf1Move = w1.suggest(g1,Move.SET);
      Grid g2 = g1.moveWolf1(wolf1Move);

      // ... pick move for wolf 2
      Move wolf2Move = w2.suggest(g2,Move.SET);
      Grid g3 = g2.moveWolf2(wolf2Move);

      if (g3.rabbitCaught()) {
        // ... raise our score a large amount
        hunt.reward(CATCH_REWARD);
        break;
      }

      g0 = g3;
      // ... lower our score a small amount
      hunt.reward(MOVE_PENALTY);
    }
  }

  private static final double CATCH_REWARD = 1000;
  private static final double MOVE_PENALTY = -1;
}
